package StdLib::Item;

use strict;
use warnings;
use include;

use StdLib;

my $item = create("Item",
  GroupBy => []   # Don't group stuff by default.
);

# Put the object where we say so.
$item->{Init} = sub {
  my ($self, $opts) = @_;

  $self->_construct($opts => "Name", "Symbol", "Color");
  $self->{Qty} = delete $opts->{Qty} || 1;

  # We're either on a map or in someone's inventory
  if (my $map = delete $opts->{On}) {
    my ($y, $x);
    # We going somewhere in particular or just anywhere?
    if ($opts->{At}) {
      ($y, $x) = @{ delete $opts->{At} };
    } else {
      ($y, $x) = $map->getpt(".");
    }
    $map->inv($y, $x, "add", $self);
  } elsif (my $owner = delete $opts->{BelongsTo}) {
    $owner->{Inv}->add($self);
  }

  return;
};

42;
