package StdLib::Item::Equipment;

use strict;
use warnings;
use include;

use StdLib;

my $equipment = create("Equipment", From => "Item");

my $weapon = create("Weapon",
  From     => "Equipment",
  Category => "Weapons",
  Fits     => ["Weapon"]
);

# The lazy way of making the equipment templates, which are all so similar.
my %wearables = (
  Armour => ["Armour"],
  Helmet => ["Helmet"],
  Amulet => ["Amulet"],
  Gloves => ["Gloves"],
  Ring   => ["LeftRing", "RightRing"],
  Boots  => ["Boots"]
);
create($_,
  From     => "Equipment",
  Category => "Armour",
  Fits     => $wearables{$_}
) foreach keys %wearables;

# Describe ourselves. You know, for personal ads. +5 equipment of.. well, you know. ;)
$equipment->{Methods}{name} = sub {
  my $self = shift;
  my $name = $self->g("Name");

  # +5? flaaaaaaaming?

  die "unnamed item!" unless $name;

  if ($self->{On}) {
    $name .= $self->{On} eq "Hand" ? " (wielded)" : " (worn)";
  }

  return $name;
};

42;
