package StdLib::Item::SingleUse;

use strict;
use warnings;
use include;

use StdLib;

my $singleuse = create("SingleUse", From => "Item", GroupBy => ["Name"]);

my $food = create("Food",
  From     => "SingleUse",
  Category => "Food",
  Symbol   => "%"
);

my $potion = create("Potion",
  From     => "SingleUse",
  Category => "Potions",
  Symbol   => "!"
);

my $scroll = create("Scroll",
  From     => "SingleUse",
  Category => "Scrolls",
  Symbol   => "?"
);

$singleuse->{Methods}{name} = sub {
  my $self = shift;

  die unless my $name = $self->g("Name");
  return $name;
};

# We've been used, diminish our quantity.
$singleuse->{Methods}{destroy} = sub {
  my $self = shift;
  if ($self->{Qty} > 1) {
    $self->{Qty}--;
    return;
  } else {
    $self->{Owner}->del($self);
  }
};

42;
